// Copyright Andrew Choi 1993, 2003.  Perl Artistic License

#import "MyWindowDelegate.h"

#include "defs.h"

@implementation MyWindowDelegate

/* We're being a bit picky.  Overriding this method ensures that the aspect ratio
   of the *content view* is correct.  If we set the aspect ratio of the window
   to the same value, we will only be getting an approximation, because we haven't
   account for the height of the window title.  */
- (NSSize)windowWillResize:(NSWindow *)sender toSize:(NSSize)proposedFrameSize
{
    float x, y, xx, yy;
    
    NSSize currWindowSize = [sender frame].size;
    NSSize currViewSize = [[sender contentView] frame].size;
    
    float titleBarHeight = currWindowSize.height - currViewSize.height;
    x = proposedFrameSize.width;
    y = proposedFrameSize.height - titleBarHeight;
    
    xx = y / VHRatio;		/* ideal value of x according to y */
    yy = x * VHRatio;		/* ideal value of y according to x */
    if (x > xx)
      x = xx;
    if (y > yy)
      y = yy;
    
    return NSMakeSize(x, y + titleBarHeight);
}

@end
