// Copyright Andrew Choi 1993, 2003.  Perl Artistic License

#ifndef __MOVEGEN_H
#define __MOVEGEN_H

#include "boardstruc.h"

#include "defs.h"

#define HorizPlus 0
#define HorizMinus 1
#define SlashPlus 2
#define SlashMinus 3
#define BSlashPlus 4
#define BSlashMinus 5

typedef MarblePosType ConnectMapType[121][6];
typedef bool OccMapType[121];

typedef struct {
  MarblePosType from;
  MarblePosType to;
} MoveType;
	
typedef MoveType *MoveList;

void BuildConnectMap(BoardType board, ConnectMapType connectMap,
		     OccMapType occMap);
void CMAdd(MarblePosType pos, ConnectMapType cM, OccMapType oM);
void CMDelete(MarblePosType pos, ConnectMapType cM, OccMapType oM);

void SelfMoveGen(BoardType board, ConnectMapType cM, OccMapType oM,
		 MoveList *result, int *resNumMoves);
void OppMoveGen(BoardType board, ConnectMapType cM, OccMapType oM,
		MoveList *result, int *resNumMoves);

#endif
