// Copyright Andrew Choi 1993, 2003.  Perl Artistic License

#include "boardstruc.h"
#include "static.h"

/* pieces not allowed in neutral zones */
#define	XX -9999

int posEvalTable[] = {
  0,
  10, 10,
  20, 20, 20,
  30, 30, 30, 30,
  XX, XX, XX, XX, 40, 41, 42, 41, 40, XX, XX, XX, XX,
  XX, XX, XX, 50, 51, 52, 52, 51, 50, XX, XX, XX,
  XX, XX, 60, 61, 62, 63, 62, 61, 60, XX, XX,
  XX, 70, 71, 72, 73, 73, 72, 71, 70, XX,
  80, 81, 82, 83, 84, 83, 82, 81, 80,
  XX, 90, 91, 92, 93, 93, 92, 91, 90, XX,
  XX, XX, 100, 101, 102, 103, 102, 101, 100, XX, XX,
  XX, XX, XX, 110, 111, 112, 112, 111, 110, XX, XX, XX,
  XX, XX, XX, XX, 120, 121, 122, 121, 120, XX, XX, XX, XX,
  130, 130, 130, 130,
  140, 140, 140,
  150, 150,
  160
};

int homeTable[] = {
  0,
  0, 0,
  0, 0, 0,
  0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  1, 1, 1, 1,
  1, 1, 1,
  1, 1,
  1
};

int StaticEval(BoardType board, int depth)
{
  int i, own, opp, ownInHome, oppInHome;

  own = 0;
  for (i = 0; i < 10; i++)
    own += posEvalTable[board[0][i]];

  ownInHome = 0;
  for (i = 0; i < 10; i++)
    ownInHome += homeTable[board[0][i]];
			
  opp = 0;
  for (i = 0; i < 10; i++)
    opp += posEvalTable[120 - board[1][i]];

  oppInHome = 0;
  for (i = 0; i < 10; i++)
    oppInHome += homeTable[120 - board[1][i]];

  if (depth % 2 == 1)
    return(opp - own + oppInHome / 10 * 9999 - ownInHome / 10 * 9999);
  else
    return(own - opp + ownInHome / 10 * 9999 - oppInHome / 10 * 9999);
}
